2021-12-01 22:09 CET

View Issue Details Jump to Notes ]
IDProjectCategoryView StatusLast Update
0005309DogsOfWar[WHDLoad Installs Games] slavepublic2021-12-01 17:20
ReporterSolo Kazuki 
Assigned ToDJ MikeProject InfoDogs of War (Elite Systems)
http://www.whdload.de/games/DogsOfWar.html
 
PrioritynormalSeverityfeatureReproducibilityN/A
StatusassignedResolutionopen 
Summary0005309: Dogs of War - 2nd button to switch weapons
DescriptionIs possible to add second button support to switching weapons (with [SHIFT]). Also pause on [PLAY]/3rd button would be nice addition.
TagsCD32 Controls, support 2nd fire button, support 3rd fire button
MachineA1200
CPU68060
CPUSpeed100
ChipSetAGA
GFXCardWarp
ChipMem2 MB
FastMem224 MB
WorkbenchOS 3.0
KickROM39 - Kick 3.0
KickSoft40 - Kick 3.1
WHDLoad18.6
imported
Attached Files

-Relationships
related to 0002845closedDJ Mike I was playing on 6th level when suddenly an "illegal instruction" occured. No 
+Relationships

-Notes

note ~0010591

JOTD (developer)

weapon selection screen seems completely trashed. Is that winuae ? dunno.

note ~0010592

Solo Kazuki (reporter)

What do You mean? Is not looks like this?
http://hol.abime.net/pic_full/screenshot/0301-0400/380_screen2.png

note ~0010595

Solo Kazuki (reporter)

https://dakkster.files.wordpress.com/2010/05/dogs-of-war_003.png

note ~0010598

JOTD (developer)

no pic is completely trashed, even with old slave. maybe it's winuae bug...

note ~0010603

DJ Mike (developer)

The weapon selection works fine on my real A1200/030, but I concur it is broken in WinUAE. This isn't the first emulator-only bug with this game I've had. Must be something unusual with the coding in this game. :-)

I'm happy to take a look at the controls since I still have my source. Not sure how solvable the WinUAE bug is...

note ~0010606

JOTD (developer)

Last edited: 2021-07-26 08:36

View 3 revisions

you can add BUTTONWAIT to see the crappy title if you want.

Playing floppy version on standard A500 configuration the pic isn't trashed.

So trashed pic probably interesting blitter error. Tried with "immediate blitter" and still no dice... Self-modifying code? that is going to be fun :)

Maybe a separate issue should be opened.

note ~0010607

DJ Mike (developer)

I tried it in WinUAE 4.4 (not beta). I'm fairly certain it worked OK at some point in the past, but that would have been many years ago. Hopefully it's a useful test case for Toni to fix an edge case.

note ~0010608

JOTD (developer)

Last edited: 2021-07-26 08:37

View 2 revisions

I just tried SPS version on WinUAE A500 config and it's okay (as said in simultaneous message above :))

note ~0010611

DJ Mike (developer)

I had tried MMU+SNOOPOCS+CHK in WHDLoad last night and didn't spot any blit wait errors - although I had already done blitwait checks back in 2006.

NOCACHE also doesn't fix this.

Wonder if it's an OCS vs ECS/AGA bug?

note ~0010621

DJ Mike (developer)

Very strange - the issue is the "disk block finished" check I patched out in v1.3, which I did for WinUAE's benefit. Originally game would hang in WinUAE due to disk never being accessed (and therefore DSKBLK bit never got set). However on a real Amiga this check completes just fine. I know Toni fixed that many years ago - and I'm sure he made it behave like a real Amiga.

So what's of more interest is why DSKBLK bit is getting set to 1 at all...

Restoring the check fixes the problem in WinUAE now, but I'm not entirely happy with that fix!

note ~0010622

DJ Mike (developer)

Have had some useful insights from Toni Wilen about this. Sounds like I might still have some stray disk code active that I need to nerf. Plenty to investigate anyway. :-)

note ~0010624

DJ Mike (developer)

Last edited: 2021-07-27 08:25

View 2 revisions

OK I fixed that. Stray bit of protection track reading code that shouldn't be running, that seems to be overwriting an area of memory with the weapons screen. This might still be a WinUAE bug so I will check my findings with Toni.

Will look at these controls next.

note ~0010629

DJ Mike (developer)

On further thought, the issue is that I'd patched out DSKBLK check (because it was hanging in old WinUAE), but had failed to spot a stray bit of disk DMA code that was trying to set up for protection track read (that only reads 0s because disk CIA is disabled in my patch).

This happens just before weapon screen is loaded to the *same address*, meaning a fast enough CPU will load the weapon screen before the disk DMA has completed, then gets overwritten with 0s. This is why the weapon screen is completely blank in WinUAE. On a real Amiga, the CPU is usually too slow to get to weapon screen before disk DMA is completed - but could probably exhibit the same bug if fast enough.

So almost certainly bug in patch after all, but I've put it to Toni in case there's anything worth following up on.

note ~0010637

Solo Kazuki (reporter)

I just add that on my A1200 with Warp1260 68060@100MHz and 224MB FastRAM everything's fine.

note ~0010638

DJ Mike (developer)

Thanks for checking. I suspect what I've observed with this bug might not even be possible on a real Amiga given the contention for chip RAM, but who knows. The fix I've added is still good to have. :)

note ~0010639

JOTD (developer)

it's always good to fix bugs that only happen because of WinUAE, because else users will report it anyway.

And there's also vampire, etc..

note ~0010702

Solo Kazuki (reporter)

Vampire have own compatibility problems, and it's still in development, so something could change in meantime. UAE it's different, but it could be compatibility problem.

BTW: I'm curious what is current state of rework?

note ~0010703

DJ Mike (developer)

Last edited: 2021-09-25 15:09

View 2 revisions

I've added weapon switching via 2nd/3rd button. Also auto-entering name on highscores by pressing fire (same as game already does if you press enter with no name). I want to add Pause button support on CD32 pads and tidy up a few things. It should be good to go soon.

note ~0010778

DJ Mike (developer)

Last edited: 2021-11-09 09:48

View 2 revisions

Apologies for the delay with this - life has been a bit busy. I've actually got this patch done bar final testing. If I post it here would anyone be up for testing it?

note ~0010779

Solo Kazuki (reporter)

Yes, I can test it.

note ~0010780

DJ Mike (developer)

OK, here's a "2.0 Pre-Release" build attached. Please let me know if there are any issues, niggles, etc. :-)

You will need to install from scratch, as I have updated the RawDIC patch as there were tracks missing in the previous version.

note ~0010781

Solo Kazuki (reporter)

I have only IPF image and cannot install from it. When I'm trying, only "RawDIC function call requires higher slave version!" information popup and nothing more.

note ~0010782

DJ Mike (developer)

Last edited: 2021-11-11 20:05

View 2 revisions

You need to update your copy of RawDIC to the version included with the latest WHDLoad, or grab it here: http://www.whdload.de/whdload/RawDIC50.lha

Although, it's curious you're getting that issue at all, as I didn't change the RawDIC version required in this install. (I have had to use a later RawDIC version for a different patch, which may be what's caused this.)

note ~0010783

Solo Kazuki (reporter)

I had RawDIC 5.0 already. Moreover it's rather about slave not RawDIC, if I udnerstand correctly.

note ~0010784

DJ Mike (developer)

Have you checked your capsimage.device is up to date? I've had errors like this in the past trying to use "Select File" with IPFs, and it turned out I needed the latest version of this for certain newer images.

note ~0010785

DJ Mike (developer)

I've rebuilt the RawDIC slave in case there was an issue with the previous RawDIC include.

note ~0010786

DJ Mike (developer)

Just to test out my above theory, I re-installed the old version of capsimage.device I used to have, and I get the same "RawDIC function call requires higher slave version!" as you.

So I am fairly certain your capsimage.device is out of date. :-)

Latest version is here: http://www.softpres.org/_media/files:ipflib_amigaos-m68k.lha?id=download&cache=cache

note ~0010788

Solo Kazuki (reporter)

Nope. I had also same capsimage.device as in mentioned archive. Still cannot install game.
I'll do it with WinUAE, but bear in mind that someone can have similar problem during installation.

note ~0010789

Solo Kazuki (reporter)

Ok. Game itself is working ok with CD32 joypad. I borrowed 3 buttons joystick for tests and I'm waiting for 3-buttons joypad. It should be already but probably earliest in monday I could check game with 3 buttons. To be sure, it should be?
2nd/blue - change weapon
3rd/play - pause

note ~0010790

DJ Mike (developer)

Last edited: 2021-11-12 18:10

View 2 revisions

I think it is very likely something is still interfering with RawDIC/capsimage.device. Unfortunately it is difficult to diagnose, because support for what goes wrong inside capsimage.device is very limited. Using WinUAE is fine. I will see if there is anything else obvious before I release but I don't think the DoW slave is the issue here.

For reference, cracked versions probably work fine as well (because the RawDIC slave supports the budget AmigaDOS version too).

Buttons are:
2nd/blue - change weapon
3rd/green - auto/manual fire toggle (on weapons that support it)
Play - pause (CD32 pads only)

I chose that combo because it seemed like mapping all gameplay functions to 3-button joystick was more useful than Pause.

note ~0010792

Solo Kazuki (reporter)

Yes, indeed. Nice to know that it's additional button to switch fire mode.
Thanks for this patch! I'll let You know how it works with 3 buttons controller ASAP.

note ~0010793

DJ Mike (developer)

How are you getting on with it? Any bugs I need to fix? :-)

note ~0010794

Solo Kazuki (reporter)

Sorry, but still I don't receive delivery with joypads. It was sent 29 October and arrived to Warsaw 4 November. Moreover when i called to infoline of delivery service I was informed that (Tadam!) it's indeed in Warsaw and envelope was wet.
Now I'm wondering when I get these joypads and in what condition...

Sorry for that, but it's not My fault.

note ~0010795

Solo Kazuki (reporter)

I forgot to mention that it was sent from Spain.

note ~0010796

DJ Mike (developer)

Last edited: 2021-11-16 16:06

View 2 revisions

I'm not too worried about specific 3 button pad checking (I can check that via WinUAE easily enough), as long as CD32 pad controls are working as expected. Are other features in the slave working as expected, game doesn't crash, etc? :)

Am happy to look into 3 button pad issues later of course if they come up once you've checked.

note ~0010797

Solo Kazuki (reporter)

If it's about CD32 joypad control, then I didn't have any problem yet. For me it's ok.

note ~0010798

Solo Kazuki (reporter)

I just played today for some time Dogs of War and have to report... not found any problem yet. :D

note ~0010799

DJ Mike (developer)

Great. :-) Thanks for trying it out!

Will get this released shortly, all being well.

note ~0010808

Solo Kazuki (reporter)

I just get my 3-buttons joypad (at last!) and test Dogs of War again for some time. All three buttons are working as they should and there was not any problem with game. It can be released with all functions working well and no problem occurs. Yet, mind that it's on my config... ;)
+Notes

-Issue History
Date Modified Username Field Change
2021-07-22 19:46 Solo Kazuki New Issue
2021-07-22 19:47 Solo Kazuki Tag Attached: CD32 Controls
2021-07-22 19:47 Solo Kazuki Tag Attached: support 2nd fire button
2021-07-22 19:47 Solo Kazuki Tag Attached: support 3rd fire button
2021-07-24 22:29 JOTD Note Added: 0010591
2021-07-24 22:29 JOTD Assigned To => JOTD
2021-07-24 22:29 JOTD Status new => assigned
2021-07-24 22:44 Solo Kazuki Note Added: 0010592
2021-07-25 13:42 Solo Kazuki Note Added: 0010595
2021-07-25 16:34 JOTD Note Added: 0010598
2021-07-26 00:30 DJ Mike Note Added: 0010603
2021-07-26 08:29 JOTD Assigned To JOTD => DJ Mike
2021-07-26 08:31 JOTD Note Added: 0010606
2021-07-26 08:33 JOTD Note Edited: 0010606 View Revisions
2021-07-26 08:35 DJ Mike Note Added: 0010607
2021-07-26 08:36 JOTD Note Edited: 0010606 View Revisions
2021-07-26 08:36 JOTD Note Added: 0010608
2021-07-26 08:37 JOTD Note Edited: 0010608 View Revisions
2021-07-26 08:53 DJ Mike Note Added: 0010611
2021-07-26 20:05 DJ Mike Note Added: 0010621
2021-07-26 20:48 DJ Mike Note Added: 0010622
2021-07-26 23:51 DJ Mike Note Added: 0010624
2021-07-27 08:25 DJ Mike Note Edited: 0010624 View Revisions
2021-07-27 11:53 DJ Mike Note Added: 0010629
2021-07-30 23:46 Solo Kazuki Note Added: 0010637
2021-07-30 23:55 DJ Mike Note Added: 0010638
2021-07-31 10:24 JOTD Note Added: 0010639
2021-08-29 16:32 Solo Kazuki Note Added: 0010702
2021-08-29 16:38 DJ Mike Note Added: 0010703
2021-09-25 15:09 DJ Mike Note Edited: 0010703 View Revisions
2021-11-09 09:48 DJ Mike Note Added: 0010778
2021-11-09 09:48 DJ Mike Note Edited: 0010778 View Revisions
2021-11-09 11:11 Solo Kazuki Note Added: 0010779
2021-11-10 19:35 DJ Mike File Added: DogsOfWar20.lha
2021-11-10 19:35 DJ Mike Note Added: 0010780
2021-11-11 15:40 Solo Kazuki Note Added: 0010781
2021-11-11 20:03 DJ Mike Note Added: 0010782
2021-11-11 20:05 DJ Mike Note Edited: 0010782 View Revisions
2021-11-11 21:29 Solo Kazuki Note Added: 0010783
2021-11-11 22:42 DJ Mike Note Added: 0010784
2021-11-11 22:46 DJ Mike File Added: DogsOfWar20a.lha
2021-11-11 22:46 DJ Mike Note Added: 0010785
2021-11-11 22:46 DJ Mike File Deleted: DogsOfWar20.lha
2021-11-11 22:52 DJ Mike Note Added: 0010786
2021-11-12 16:36 Solo Kazuki Note Added: 0010788
2021-11-12 17:05 Solo Kazuki Note Added: 0010789
2021-11-12 18:05 DJ Mike Note Added: 0010790
2021-11-12 18:07 DJ Mike Relationship added related to 0002845
2021-11-12 18:10 DJ Mike Note Edited: 0010790 View Revisions
2021-11-12 18:25 Solo Kazuki Note Added: 0010792
2021-11-16 11:27 DJ Mike Note Added: 0010793
2021-11-16 13:29 Solo Kazuki Note Added: 0010794
2021-11-16 13:34 Solo Kazuki Note Added: 0010795
2021-11-16 15:17 DJ Mike Note Added: 0010796
2021-11-16 16:06 DJ Mike Note Edited: 0010796 View Revisions
2021-11-16 16:45 Solo Kazuki Note Added: 0010797
2021-11-19 17:35 Solo Kazuki Note Added: 0010798
2021-11-20 10:09 DJ Mike Note Added: 0010799
2021-12-01 17:20 Solo Kazuki Note Added: 0010808
+Issue History